# Stubs for mistune (Python 2)
#
# NOTE: This dynamically typed stub was automatically generated by stubgen.

from typing import Any

def escape(text, quote=False, smart_amp=True): ...

class BlockGrammar:
    def_links = ... # type: Any
    def_footnotes = ... # type: Any
    newline = ... # type: Any
    block_code = ... # type: Any
    fences = ... # type: Any
    hrule = ... # type: Any
    heading = ... # type: Any
    lheading = ... # type: Any
    block_quote = ... # type: Any
    list_block = ... # type: Any
    list_item = ... # type: Any
    list_bullet = ... # type: Any
    paragraph = ... # type: Any
    block_html = ... # type: Any
    table = ... # type: Any
    nptable = ... # type: Any
    text = ... # type: Any

class BlockLexer:
    grammar_class = ... # type: Any
    default_rules = ... # type: Any
    list_rules = ... # type: Any
    footnote_rules = ... # type: Any
    tokens = ... # type: Any
    def_links = ... # type: Any
    def_footnotes = ... # type: Any
    rules = ... # type: Any
    def __init__(self, rules=None, **kwargs): ...
    def __call__(self, text, rules=None): ...
    def parse(self, text, rules=None): ...
    def parse_newline(self, m): ...
    def parse_block_code(self, m): ...
    def parse_fences(self, m): ...
    def parse_heading(self, m): ...
    def parse_lheading(self, m): ...
    def parse_hrule(self, m): ...
    def parse_list_block(self, m): ...
    def parse_block_quote(self, m): ...
    def parse_def_links(self, m): ...
    def parse_def_footnotes(self, m): ...
    def parse_table(self, m): ...
    def parse_nptable(self, m): ...
    def parse_block_html(self, m): ...
    def parse_paragraph(self, m): ...
    def parse_text(self, m): ...

class InlineGrammar:
    escape = ... # type: Any
    inline_html = ... # type: Any
    autolink = ... # type: Any
    link = ... # type: Any
    reflink = ... # type: Any
    nolink = ... # type: Any
    url = ... # type: Any
    double_emphasis = ... # type: Any
    emphasis = ... # type: Any
    code = ... # type: Any
    linebreak = ... # type: Any
    strikethrough = ... # type: Any
    footnote = ... # type: Any
    text = ... # type: Any
    def hard_wrap(self): ...

class InlineLexer:
    grammar_class = ... # type: Any
    default_rules = ... # type: Any
    inline_html_rules = ... # type: Any
    renderer = ... # type: Any
    links = ... # type: Any
    footnotes = ... # type: Any
    footnote_index = ... # type: Any
    rules = ... # type: Any
    def __init__(self, renderer, rules=None, **kwargs): ...
    def __call__(self, text, rules=None): ...
    def setup(self, links, footnotes): ...
    line_match = ... # type: Any
    line_started = ... # type: Any
    def output(self, text, rules=None): ...
    def output_escape(self, m): ...
    def output_autolink(self, m): ...
    def output_url(self, m): ...
    def output_inline_html(self, m): ...
    def output_footnote(self, m): ...
    def output_link(self, m): ...
    def output_reflink(self, m): ...
    def output_nolink(self, m): ...
    def output_double_emphasis(self, m): ...
    def output_emphasis(self, m): ...
    def output_code(self, m): ...
    def output_linebreak(self, m): ...
    def output_strikethrough(self, m): ...
    def output_text(self, m): ...

class Renderer:
    options = ... # type: Any
    def __init__(self, **kwargs) -> None: ...
    def placeholder(self): ...
    def block_code(self, code, lang=None): ...
    def block_quote(self, text): ...
    def block_html(self, html): ...
    def header(self, text, level, raw=None): ...
    def hrule(self): ...
    def list(self, body, ordered=True): ...
    def list_item(self, text): ...
    def paragraph(self, text): ...
    def table(self, header, body): ...
    def table_row(self, content): ...
    def table_cell(self, content, **flags): ...
    def double_emphasis(self, text): ...
    def emphasis(self, text): ...
    def codespan(self, text): ...
    def linebreak(self): ...
    def strikethrough(self, text): ...
    def text(self, text): ...
    def autolink(self, link, is_email=False): ...
    def link(self, link, title, text): ...
    def image(self, src, title, text): ...
    def inline_html(self, html): ...
    def newline(self): ...
    def footnote_ref(self, key, index): ...
    def footnote_item(self, key, text): ...
    def footnotes(self, text): ...

class Markdown:
    renderer = ... # type: Any
    inline = ... # type: Any
    block = ... # type: Any
    footnotes = ... # type: Any
    tokens = ... # type: Any
    def __init__(self, renderer=None, inline=None, block=None, **kwargs): ...
    def __call__(self, text): ...
    def render(self, text): ...
    def parse(self, text): ...
    token = ... # type: Any
    def pop(self): ...
    def peek(self): ...
    def output(self, text, rules=None): ...
    def tok(self): ...
    def tok_text(self): ...
    def output_newline(self): ...
    def output_hrule(self): ...
    def output_heading(self): ...
    def output_code(self): ...
    def output_table(self): ...
    def output_block_quote(self): ...
    def output_list(self): ...
    def output_list_item(self): ...
    def output_loose_item(self): ...
    def output_footnote(self): ...
    def output_close_html(self): ...
    def output_open_html(self): ...
    def output_paragraph(self): ...
    def output_text(self): ...

def markdown(text: str, escape: bool=True, **kwargs) -> str: ...
